VirtualBox

source: vbox/trunk/configure@ 47469

Last change on this file since 47469 was 46279, checked in by vboxsync, 11 years ago

configure: recognize --disable-libvpx

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 72.4 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2013 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr '[:upper:]' '[:lower:]'`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 haiku)
58 ;;
59 *)
60 echo "Cannot determine OS!"
61 exit 1
62 ;;
63esac
64
65#
66# Defaults
67#
68OSE=1
69ODIR="`pwd`/"
70ODIR_OVERRIDE=0
71OUT_PATH=""
72OUT_PATH_OVERRIDE=0
73SETUP_WINE=
74TARGET_MACHINE=""
75TARGET_CPU=""
76WITH_XPCOM=1
77WITH_PYTHON=1
78WITH_JAVA=1
79WITH_VMMRAW=1
80WITH_LIBIDL=1
81WITH_GSOAP=0
82WITH_QT4=1
83WITH_SDL=1
84WITH_SDL_TTF=1
85WITH_X11=1
86WITH_ALSA=1
87WITH_PULSE=1
88WITH_DBUS=1
89WITH_DEVMAPPER=1
90WITH_KMODS=1
91WITH_OPENGL=1
92WITH_HARDENING=1
93WITH_UDPTUNNEL=1
94WITH_VDE=0
95WITH_VNC=0
96WITH_EXTPACK=1
97WITH_DOCS=1
98WITH_LIBVPX=1
99BUILD_LIBXML2=
100BUILD_LIBCURL=
101BUILD_LIBSSL=
102BUILD_LIBVPX=
103PASSIVE_MESA=0
104CC="gcc"
105CC32=""
106CC64=""
107CXX="g++"
108CXX32=""
109CXX64=""
110YASM="yasm"
111IASL="iasl"
112XSLTPROC="xsltproc"
113GENISOIMAGE="genisoimage"
114MKISOFS="mkisofs"
115INCCRYPTO=""
116LIBCRYPTO="-lssl -lcrypto"
117LIBPTHREAD="-lpthread"
118LIBCAP="-lcap"
119GSOAP=""
120GSOAP_IMPORT=""
121INCX11="/usr/local/include"
122LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
123LIBXCURSOR="-lXcursor"
124LIBXMU="-lXmu"
125LIBXINERAMA="-lXinerama"
126LIBXRANDR="-lXrandr"
127MAKESELF="makeself"
128MESA="-lGL"
129INCZ=""
130LIBZ="-lz"
131INCVNCSERVER=""
132LIBVNCSERVER="-lvncserver"
133INCDEVMAPPER=""
134LIBDEVMAPPER="-ldevmapper"
135CXX_FLAGS=""
136if [ "$OS" = "freebsd" ]; then
137 INCCURL="-I/usr/local/include"
138 LIBCURL="-L/usr/local/lib -lcurl"
139 INCPULSE="-I/usr/local/include"
140 LIBPULSE="-L/usr/local/lib"
141 INCPNG="-I/usr/local/include"
142 LIBPNG="-L/usr/local/lib -lpng"
143else
144 INCCURL=""
145 LIBCURL="-lcurl"
146 INCPNG=""
147 LIBPNG="-lpng"
148fi
149INCVPX=""
150LIBVPX="-lvpx"
151PKGCONFIG="`which_wrapper pkg-config`"
152PYTHONDIR="/usr /usr/local"
153QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
154QT4DIR_PKGCONFIG=1
155QT4UIC3DIR="/usr/bin"
156KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
157DEVDIR="`cd \`dirname $0\`; pwd`/tools"
158if [ -d "/lib/modules/`uname -r`/build" ]; then
159 LINUX="/lib/modules/`uname -r`/build"
160else
161 LINUX="/usr/src/linux"
162fi
163KCHMVIEWER="kchmviewer"
164LOG="configure.log"
165CNF="AutoConfig.kmk"
166ENV="env.sh"
167BUILD_TYPE="release"
168# the restricting tool is ar (mri mode).
169INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
170
171if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
172 echo "Error: VBox base path contains invalid characters!"
173 exit 1
174fi
175
176# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
177if [ "$OS" = "darwin" ]; then
178 ECHO_N="/bin/echo -n"
179else
180 ECHO_N="echo -n"
181fi
182
183
184cleanup()
185{
186 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
187}
188
189fail()
190{
191 if [ -z "$nofatal" -o "x$1" != "x" ]; then
192 cleanup
193 rm -f $ENV
194 echo "Check $LOG for details"
195 exit 1
196 fi
197}
198
199log()
200{
201 echo "$1"
202 echo "$1" >> $LOG
203}
204
205log_success()
206{
207 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
208 echo "OK."
209 echo "$1" >> $LOG
210 echo >> $LOG
211 echo >> $LOG
212}
213
214log_failure()
215{
216 echo
217 echo " ** $1!"
218 echo "** $1!" >> $LOG
219 echo >> $LOG
220}
221
222cnf_append()
223{
224 printf "%-30s := %s\n" "$1" "$2" >> $CNF
225}
226
227strip_l()
228{
229 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
230}
231
232strip_L()
233{
234 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
235}
236
237strip_I()
238{
239 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
240}
241
242prefix_I()
243{
244 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
245}
246
247check_avail()
248{
249 if [ -z "$1" ]; then
250 log_failure "$2 is empty"
251 fail $3
252 return 1
253 elif which_wrapper $1 > /dev/null; then
254 return 0
255 else
256 log_failure "$1 (variable $2) not found"
257 fail $3
258 return 1
259 fi
260}
261
262
263# Prepare a test
264test_header()
265{
266 echo "***** Checking $1 *****" >> $LOG
267 $ECHO_N "Checking for $1: "
268}
269
270
271# Compile a test
272# $1 compile flags/libs
273# $2 library name
274# $3 package name
275# $4 if this argument is 'nofatal', don't abort
276test_compile()
277{
278 echo "compiling the following source file:" >> $LOG
279 cat $ODIR.tmp_src.cc >> $LOG
280 echo "using the following command line:" >> $LOG
281 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
282 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
283 if [ $? -ne 0 ]; then
284 if [ -z "$4" ]; then
285 echo
286 echo " $2 not found at $1 or $3 headers not found"
287 echo " Check the file $LOG for detailed error information."
288 fail
289 else
290 echo >> $LOG
291 echo >> $LOG
292 fi
293 return 1
294 fi
295 return 0
296}
297
298
299# Execute a compiled test binary
300test_execute()
301{
302 echo "executing the binary" >> $LOG
303 $ODIR.tmp_out > $ODIR.test_execute.log
304 rc=$?
305 cat $ODIR.test_execute.log | tee -a $LOG
306 if [ $rc -ne 0 ]; then
307 fail $1
308 return 1
309 fi
310 echo >> $LOG
311 echo >> $LOG
312 return 0
313}
314
315
316# Execute a compiled test binary
317test_execute_path()
318{
319 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
320 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
321 rc=$?
322 cat $ODIR.test_execute.log | tee -a $LOG
323 if [ $rc -ne 0 ]; then
324 fail
325 return 1
326 fi
327 echo >> $LOG
328 echo >> $LOG
329 return 0
330}
331
332
333#
334# Check for OS, MACHINE, CPU
335#
336check_environment()
337{
338 test_header environment
339 BUILD_CPU=`uname -m`
340 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
341 case "$BUILD_CPU" in
342 i[3456789]86|x86|i86pc|BePC)
343 BUILD_MACHINE='x86'
344 LIB='lib'
345 ;;
346 x86_64|amd64)
347 BUILD_MACHINE='amd64'
348 BUILD_CPU='k8'
349 if [ "$OS" != "solaris" ]; then
350 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
351 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
352 LIB='lib64'
353 else
354 # Solaris doesn't seem to subscribe to fhs, libs are usually in
355 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
356 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
357 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
358 # have to make sure the */bin/amd64 dirs are searched before the */bin
359 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
360 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
361 echo "old PATH: $PATH" >> $LOG
362 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
363 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
364 export PATH
365 echo "new PATH: $PATH" >> $LOG
366 LIB='lib/64'
367 fi
368 ;;
369 *)
370 log_failure "Cannot determine system"
371 exit 1
372 ;;
373 esac
374 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
375 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
376 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
377 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
378
379 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
380 echo "export BUILD_PLATFORM" >> $ENV
381 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
382 echo "export BUILD_PLATFORM_ARCH" >> $ENV
383 echo "BUILD_TARGET=\"$OS\"" >> $ENV
384 echo "export BUILD_TARGET" >> $ENV
385 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
386 echo "export BUILD_TARGET_ARCH" >> $ENV
387 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
388 echo "export BUILD_TARGET_CPU" >> $ENV
389 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
390 echo "export BUILD_TYPE" >> $ENV
391}
392
393#
394# Check for gcc with version >= 3.2.
395# We depend on a working gcc, if we fail terminate in every case.
396#
397check_gcc()
398{
399 test_header gcc
400 if check_avail "$CC" CC really; then
401 cc_ver=`$CC -dumpversion` 2>/dev/null
402 if [ $? -ne 0 ]; then
403 log_failure "cannot execute '$CC -dumpversion'"
404 fail really
405 fi
406 if check_avail "$CXX" CXX really; then
407 cxx_ver=`$CXX -dumpversion` 2>/dev/null
408 if [ $? -ne 0 ]; then
409 log_failure "cannot execute '$CXX -dumpversion'"
410 fail really
411 fi
412 cc_maj=`echo $cc_ver|cut -d. -f1`
413 cc_min=`echo $cc_ver|cut -d. -f2`
414 if [ "x$cc_ver" != "x$cxx_ver" ]; then
415 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
416 fail really
417 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
418 log_success "found version $cc_ver"
419 # gcc-4.0 is allowed for Darwin only
420 elif [ $cc_maj -lt 3 \
421 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
422 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
423 -o \( $cc_maj -eq 4 -a $cc_min -gt 8 \) \
424 -o $cc_maj -gt 4 ]; then
425 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<8"
426 fail really
427 else
428 log_success "found version $cc_ver"
429 fi
430 if [ "$BUILD_MACHINE" = "amd64" ]; then
431 [ -z "$CC32" ] && CC32="$CC -m32"
432 [ -z "$CXX32" ] && CXX32="$CXX -m32"
433 else
434 [ -z "$CC32" ] && CC32="$CC"
435 [ -z "$CXX32" ] && CXX32="$CXX"
436 fi
437 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
438 [ -z "$CC64" ] && CC64="$CC -m64"
439 [ -z "$CXX64" ] && CXX64="$CXX -m64"
440 fi
441 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
442 CC32="undefined"
443 CXX32="undefined"
444 fi
445 if [ "$CC" != "gcc" ]; then
446 cnf_append "TOOL_GCC3_CC" "$CC"
447 cnf_append "TOOL_GCC3_AS" "$CC"
448 cnf_append "TOOL_GCC3_LD" "$CC"
449 cnf_append "TOOL_GXX3_CC" "$CC"
450 cnf_append "TOOL_GXX3_AS" "$CC"
451 fi
452 if [ "$CXX" != "g++" ]; then
453 cnf_append "TOOL_GCC3_CXX" "$CXX"
454 cnf_append "TOOL_GXX3_CXX" "$CXX"
455 cnf_append "TOOL_GXX3_LD" "$CXX"
456 fi
457 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
458 cnf_append "TOOL_GCC32_CC" "$CC32"
459 cnf_append "TOOL_GCC32_AS" "$CC32"
460 cnf_append "TOOL_GCC32_LD" "$CC32"
461 cnf_append "TOOL_GXX32_CC" "$CC32"
462 cnf_append "TOOL_GXX32_AS" "$CC32"
463 fi
464 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
465 cnf_append "TOOL_GCC32_CXX" "$CXX32"
466 cnf_append "TOOL_GXX32_CXX" "$CXX32"
467 cnf_append "TOOL_GXX32_LD" "$CXX32"
468 fi
469 # this isn't not necessary, there is not such tool.
470 if [ -n "$CC64" ]; then
471 cnf_append "TOOL_GCC64_CC" "$CC64"
472 cnf_append "TOOL_GCC64_AS" "$CC64"
473 cnf_append "TOOL_GCC64_LD" "$CC64"
474 cnf_append "TOOL_GXX64_CC" "$CC64"
475 cnf_append "TOOL_GXX64_AS" "$CC64"
476 fi
477 if [ -n "$CXX64" ]; then
478 cnf_append "TOOL_GCC64_CXX" "$CXX64"
479 cnf_append "TOOL_GXX64_CXX" "$CXX64"
480 cnf_append "TOOL_GXX64_LD" "$CXX64"
481 fi
482 # Solaris sports a 32-bit gcc/g++.
483 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
484 [ "$CC" = "gcc" ] && CC="gcc -m64"
485 [ "$CXX" = "g++" ] && CXX="g++ -m64"
486 fi
487 fi
488 fi
489}
490
491
492#
493# Check for the OpenWatcom compiler, needed for compiling the BIOS
494#
495# If the system has Open Watcom installed, WATCOM will be set in the
496# environment. If the user has her/his own Open Watcom install it will be
497# pointed to by on the command line, which will set the WATCOM variable.
498# The only exception is detecting OpenWatcom in tools/common/openwatcom.
499#
500check_open_watcom()
501{
502 test_header "Open Watcom"
503
504 if [ -z "$WATCOM" ]; then
505 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
506 if [ -z "$WATCOM" ]; then
507 log_failure "Open Watcom was not found"
508 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
509 return 0;
510 fi
511 fi
512
513 case "$OS" in
514 "darwin") wc_bin="binosx";; # ??
515 "dos") wc_bin="binw";;
516 "freebsd") wc_bin="binfbsd";; # ??
517 "linux") wc_bin="binl";;
518 "solaris") wc_bin="binsol";; # ??
519 "os2") wc_bin="binp";;
520 "win") wc_bin="binnt";;
521 *) wc_bin="binl";;
522 esac
523
524 # Check that the tools we use are there.
525 for prog in wasm wcc wlink;
526 do
527 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
528 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
529 fail
530 fi
531 done
532
533 # Use WASM to get the version.
534 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
535 if [ -z "$wasm_ver" ]; then
536 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
537 fail
538 fi
539 log_success "found version $wasm_ver"
540 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
541 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
542
543 unset wasm_ver
544 unset wc_wasm
545 unset wc_bin
546}
547
548
549#
550# Check for yasm, needed to compile assembler files
551#
552check_yasm()
553{
554 test_header yasm
555 if check_avail "$YASM" YASM; then
556 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
557 if [ $? -ne 0 ]; then
558 log_failure "yasm not found"
559 fail
560 else
561 yasm_maj=`echo $yasm_ver|cut -d. -f1`
562 yasm_min=`echo $yasm_ver|cut -d. -f2`
563 yasm_rev=`echo $yasm_ver|cut -d. -f3`
564 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
565 if [ $yasm_ver_mul -lt 501 ]; then
566 log_failure "found version $yasm_ver, expected at least 0.5.1"
567 fail
568 else
569 log_success "found version $yasm_ver"
570 fi
571 fi
572 fi
573}
574
575
576#
577# Check for the iasl ACPI compiler, needed to compile vbox.dsl
578#
579check_iasl()
580{
581 test_header iasl
582 if check_avail "$IASL" IASL; then
583 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
584 if [ $? -ne 0 ]; then
585 log_failure "iasl not found"
586 fail
587 else
588 log_success "found version $iasl_ver"
589 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
590 fi
591 fi
592}
593
594
595#
596# Check for xsltproc, needed by Main
597#
598check_xsltproc()
599{
600 if [ -n "$BUILD_LIBXSLT" ]; then
601 return 0;
602 fi
603 test_header xslt
604 if check_avail "$XSLTPROC" XSLTPROC; then
605 xsltproc_ver=`$XSLTPROC --version`
606 if [ $? -ne 0 ]; then
607 log_failure "xsltproc not found"
608 fail
609 else
610 log_success "found"
611 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
612 fi
613 fi
614}
615
616
617#
618# Check for mkisofs, needed to build the CDROM image containing the additions
619#
620check_mkisofs()
621{
622 test_header mkisofs
623 if which_wrapper $GENISOIMAGE > /dev/null; then
624 mkisofs_ver=`$GENISOIMAGE --version`
625 if [ $? -ne 0 ]; then
626 log_failure "mkisofs not found"
627 fail
628 else
629 log_success "found $mkisofs_ver"
630 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
631 fi
632 elif check_avail "$MKISOFS" MKISOFS; then
633 mkisofs_ver=`$MKISOFS --version`
634 if [ $? -ne 0 ]; then
635 log_failure "mkisofs not working"
636 fail
637 else
638 log_success "found $mkisofs_ver"
639 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
640 fi
641 fi
642}
643
644
645#
646# Check for libxml2, needed by VBoxSettings and Runtime.
647# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
648#
649check_libxml2()
650{
651 if [ -z "$BUILD_LIBXML2" ]; then
652 test_header libxml2
653 if which_wrapper pkg-config > /dev/null; then
654 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
655 if [ $? -ne 0 ]; then
656 log_failure "libxml2 not found"
657 fail
658 else
659 FLGXML2=`pkg-config libxml-2.0 --cflags`
660 INCXML2=`strip_I "$FLGXML2"`
661 LIBXML2=`pkg-config libxml-2.0 --libs`
662 cat > $ODIR.tmp_src.cc << EOF
663#include <cstdio>
664#include <libxml/xmlversion.h>
665extern "C" int main(void)
666{
667 printf("found version %s", LIBXML_DOTTED_VERSION);
668#if LIBXML_VERSION >= 20626
669 printf(", OK.\n");
670 return 0;
671#else
672 printf(", expected version 2.6.26 or higher\n");
673 return 1;
674#endif
675}
676EOF
677 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
678 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
679 if test_execute; then
680 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
681 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
682 fi
683 fi
684 fi
685 elif which_wrapper xml2-config; then
686 libxml2_ver=`xml2-config --version`
687 if [ $? -ne 0 ]; then
688 log_failure "xml2-config not found"
689 fail
690 else
691 log_success "found version $libxml2_ver"
692 FLGXML2=`xml2-config --cflags`
693 INCXML2=`strip_I "$FLGXML2"`
694 LIBXML2=`xml2-config --libs`
695 cat > $ODIR.tmp_src.cc << EOF
696#include <cstdio>
697#include <libxml/xmlversion.h>
698extern "C" int main(void)
699{
700 printf("found version %s", LIBXML_DOTTED_VERSION);
701#if LIBXML_VERSION >= 20626
702 printf(", OK.\n");
703 return 0;
704#else
705 printf(", expected version 2.6.26 or higher\n");
706 return 1;
707#endif
708}
709EOF
710 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
711 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
712 if test_execute; then
713 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
714 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
715 fi
716 fi
717 fi
718 else
719 log_failure "neither pkg-config nor xml2-config found"
720 fail
721 fi
722 fi
723}
724
725
726#
727# Check for libIDL, needed by xpcom
728#
729check_libidl()
730{
731 test_header libIDL
732
733 if which_wrapper libIDL-config-2 > /dev/null; then
734 libidl_ver=`libIDL-config-2 --version`
735 if [ $? -ne 0 ]; then
736 log_failure "libIDL-config-2 not working"
737 fail
738 else
739 log_success "found version $libidl_ver"
740 cnf_append "VBOX_LIBIDL_CONFIG" \
741 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
742 fi
743 elif check_avail "libIDL-config" libIDL-config; then
744 libidl_ver=`libIDL-config --version`
745 if [ $? -ne 0 ]; then
746 log_failure "libIDL-config not working"
747 fail
748 else
749 log_success "found version $libidl_ver"
750 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
751 fi
752 fi
753}
754
755
756#
757# Check for libdevmapper, needed by the VBoxVolInfo
758#
759check_libdevmapper()
760{
761 test_header libdevmapper
762 cat > $ODIR.tmp_src.cc << EOF
763#include <cstdio>
764extern "C" {
765#define private
766#include <libdevmapper.h>
767int main()
768{
769 char version[80];
770
771 if (!dm_get_library_version(version, sizeof(version)))
772 {
773 printf("dm_get_library_version() failed.\n");
774 return 1;
775 }
776
777 const char* v=version;
778 unsigned int major = 0, minor = 0, micro = 0;
779
780 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
781 if (*v == '.') v++;
782 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
783 if (*v == '.') v++;
784 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
785
786 printf("found version %s", version);
787 if (major*10000 + minor*100 + micro >= 10200)
788 {
789 printf(", OK.\n");
790 return 0;
791 }
792 else
793 {
794 printf(", expected version 1.02 or higher\n");
795 return 1;
796 }
797}
798}
799EOF
800 if test_compile "$LIBDEVMAPPER $INCDEVMAPPER" libdevmapper libdevmapper; then
801 if test_execute; then
802 cnf_append "VBOX_WITH_DEVMAPPER" "1"
803 fi
804 fi
805}
806
807
808#
809# Check for openssl, needed for RDP and S3
810#
811check_ssl()
812{
813 if [ -z "$BUILD_LIBSSL" ]; then
814 test_header ssl
815 cat > $ODIR.tmp_src.cc << EOF
816#include <cstdio>
817#include <openssl/opensslv.h>
818#include <openssl/ssl.h>
819extern "C" int main(void)
820{
821 printf("found version %s", OPENSSL_VERSION_TEXT);
822 SSL_library_init();
823#if OPENSSL_VERSION_NUMBER >= 0x00908000
824 printf(", OK.\n");
825 return 0;
826#else
827 printf(", expected version 0.9.8 or higher\n");
828 return 1;
829#endif
830}
831EOF
832 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
833 if test_execute nofatal; then
834 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
835 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
836 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
837 fi
838 fi
839 fi
840}
841
842
843#
844# Check for pthread, needed by VBoxSVC, frontends, ...
845#
846check_pthread()
847{
848 test_header pthread
849 cat > $ODIR.tmp_src.cc << EOF
850#include <cstdio>
851#include <pthread.h>
852extern "C" int main(void)
853{
854 pthread_mutex_t mutex;
855 if (pthread_mutex_init(&mutex, NULL)) {
856 printf("pthread_mutex_init() failed\n");
857 return 1;
858 }
859 if (pthread_mutex_lock(&mutex)) {
860 printf("pthread_mutex_lock() failed\n");
861 return 1;
862 }
863 if (pthread_mutex_unlock(&mutex)) {
864 printf("pthread_mutex_unlock() failed\n");
865 return 1;
866 }
867 printf("found, OK.\n");
868}
869EOF
870 if test_compile $LIBPTHREAD pthread pthread; then
871 if test_execute; then
872 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
873 fi
874 fi
875}
876
877
878#
879# Check for zlib, needed by VBoxSVC, Runtime, ...
880#
881check_z()
882{
883 test_header zlib
884 cat > $ODIR.tmp_src.cc << EOF
885#include <cstdio>
886#include <zlib.h>
887extern "C" int main(void)
888{
889 printf("found version %s", ZLIB_VERSION);
890#if ZLIB_VERNUM >= 0x1210
891 printf(", OK.\n");
892 return 0;
893#else
894 printf(", expected version 1.2.1 or higher\n");
895 return 1;
896#endif
897}
898EOF
899 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
900 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
901 if test_execute; then
902 echo "if1of (\$(KBUILD_TARGET),darwin freebsd haiku linux solaris)" >> $CNF
903 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
904 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
905 echo "endif" >> $CNF
906 fi
907 fi
908}
909
910
911#
912# Check for libpng, needed by kchmviewer
913#
914check_png()
915{
916 test_header libpng
917 cat > $ODIR.tmp_src.cc << EOF
918#include <cstdio>
919#include <png.h>
920extern "C" int main(void)
921{
922 printf("found version %s", PNG_LIBPNG_VER_STRING);
923#if PNG_LIBPNG_VER >= 10205
924 printf(", OK.\n");
925 return 0;
926#else
927 printf(", expected version 1.2.5 or higher\n");
928 return 1;
929#endif
930}
931EOF
932 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
933 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
934 if test_execute; then
935 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
936 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
937 fi
938 fi
939}
940
941#
942# Check for libvncserver, needed for VNC in OSE
943#
944check_vncserver()
945{
946 test_header libvncserver
947 cat > $ODIR.tmp_src.cc <<EOF
948#include <cstdio>
949#include <rfb/rfbconfig.h>
950
951extern "C" int main()
952{
953 const char* v=LIBVNCSERVER_VERSION;
954 unsigned int major = 0, minor = 0, micro = 0;
955
956 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
957 if (*v == '.') v++;
958 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
959 if (*v == '.') v++;
960 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
961
962 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
963 if (major*10000 + minor*100 + micro >= 900)
964 {
965 printf(", OK.\n");
966 return 0;
967 }
968 else
969 {
970 printf(", expected version 0.9 or higher\n");
971 return 1;
972 }
973}
974EOF
975 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
976 if test_execute; then
977 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
978 fi
979 fi
980}
981
982#
983# Check for libcurl, needed by S3
984#
985check_curl()
986{
987 if [ -z "$BUILD_LIBCURL" ]; then
988 test_header libcurl
989 cat > $ODIR.tmp_src.cc << EOF
990#include <cstdio>
991#include <curl/curl.h>
992extern "C" int main(void)
993{
994 printf("found version %s", LIBCURL_VERSION);
995#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71901
996 printf(", OK.\n");
997 return 0;
998#else
999 printf(", expected version 7.19.1 or higher\n");
1000 return 1;
1001#endif
1002}
1003EOF
1004 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1005 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1006 if test_execute; then
1007 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1008 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1009 fi
1010 fi
1011 fi
1012}
1013
1014
1015#
1016# Check for pam, needed by VRDPAuth
1017# Version 79 was introduced in 9/2005, do we support older versions?
1018# Debian/sarge uses 76
1019# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1020#
1021check_pam()
1022{
1023 test_header pam
1024 cat > $ODIR.tmp_src.cc << EOF
1025#include <cstdio>
1026#include <security/pam_appl.h>
1027extern "C" int main(void)
1028{
1029 printf("found version %d", __LIBPAM_VERSION);
1030 if (__LIBPAM_VERSION >= 76)
1031 {
1032 printf(", OK.\n");
1033 return 0;
1034 }
1035 else
1036 {
1037 printf(", expected version 76 or higher\n");
1038 return 1;
1039 }
1040}
1041EOF
1042 if test_compile "-lpam" pam pam nofatal; then
1043 if test_execute nofatal; then
1044 return 0;
1045 fi
1046 fi
1047 echo "pam0.x not found"
1048 test_header linux_pam
1049 cat > $ODIR.tmp_src.cc << EOF
1050#include <cstdio>
1051#include <security/pam_appl.h>
1052extern "C" int main(void)
1053{
1054 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1055 if (__LINUX_PAM__ >= 1)
1056 {
1057 printf(", OK.\n");
1058 return 0;
1059 }
1060 else
1061 {
1062 printf(", expected version 1.0 or higher\n");
1063 return 1;
1064 }
1065}
1066EOF
1067 if test_compile "-lpam" pam pam; then
1068 test_execute
1069 fi
1070}
1071
1072
1073#
1074# Check for the SDL library, needed by VBoxSDL and VirtualBox
1075# We depend at least on version 1.2.7
1076#
1077check_sdl()
1078{
1079 test_header SDL
1080 if [ "$OS" = "darwin" ]; then
1081 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1082 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1083 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1084 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1085 fi
1086 if [ -n "$PATH_SDK_LIBSDL" ]; then
1087 foundsdl=1
1088 INCSDL="$PATH_SDK_LIBSDL/Headers"
1089 FLDSDL="-framework SDL"
1090 else
1091 log_failure "SDL framework not found"
1092 fail
1093 fi
1094 else
1095 if which_wrapper sdl-config > /dev/null; then
1096 FLGSDL=`sdl-config --cflags`
1097 INCSDL=`strip_I "$FLGSDL"`
1098 LIBSDL=`sdl-config --libs`
1099 LIBSDLMAIN="-lSDLmain"
1100 FLDSDL=
1101 foundsdl=1
1102 fi
1103 fi
1104 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1105 if [ -n "$foundsdl" ]; then
1106 cat > $ODIR.tmp_src.cc << EOF
1107#include <cstdio>
1108#include <SDL.h>
1109#include <SDL_main.h>
1110#undef main
1111extern "C" int main(int argc, char** argv)
1112{
1113 printf("found version %d.%d.%d",
1114 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1115#if SDL_VERSION_ATLEAST(1,2,7)
1116 printf(", OK.\n");
1117 return 0;
1118#else
1119 printf(", expected version 1.2.7 or higher\n");
1120 return 1;
1121#endif
1122}
1123EOF
1124 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1125 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1126 if test_execute; then
1127 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1128 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1129 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1130 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1131 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1132 fi
1133 fi
1134 else
1135 log_failure "SDL not found"
1136 fail
1137 fi
1138}
1139
1140
1141#
1142# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1143#
1144check_sdl_ttf()
1145{
1146 test_header SDL_ttf
1147 cat > $ODIR.tmp_src.cc << EOF
1148#include <cstdio>
1149#include <SDL_ttf.h>
1150#ifndef SDL_TTF_MAJOR_VERSION
1151#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1152#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1153#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1154#endif
1155extern "C" int main(void)
1156{
1157 printf("found version %d.%d.%d",
1158 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1159#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1160 printf(", OK.\n");
1161 return 0;
1162#else
1163 printf(", expected version 2.0.6 or higher\n");
1164 return 1;
1165#endif
1166}
1167EOF
1168 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1169 if ! test_execute nofatal; then
1170 cnf_append "VBOX_WITH_SECURELABEL" ""
1171 fi
1172 else
1173 echo "not found -- disabling VBoxSDL secure label."
1174 cnf_append "VBOX_WITH_SECURELABEL" ""
1175 fi
1176}
1177
1178
1179#
1180# Check for libasound, needed by the ALSA audio backend
1181#
1182check_alsa()
1183{
1184 test_header ALSA
1185 cat > $ODIR.tmp_src.cc << EOF
1186#include <cstdio>
1187#include <alsa/asoundlib.h>
1188extern "C" int main(void)
1189{
1190 printf("found version %d.%d.%d",
1191 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1192#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1193 printf(", OK.\n");
1194 return 0;
1195#else
1196 printf(", expected version 1.0.6 or higher\n");
1197 return 1;
1198#endif
1199}
1200EOF
1201 if test_compile "-lasound" asound asound; then
1202 test_execute
1203 fi
1204}
1205
1206
1207#
1208# Check for PulseAudio
1209#
1210check_pulse()
1211{
1212 test_header "PulseAudio"
1213 cat > $ODIR.tmp_src.cc << EOF
1214#include <cstdio>
1215#include <pulse/version.h>
1216extern "C" int main(void)
1217{
1218 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1219#if PA_API_VERSION >= 9
1220 printf(", OK.\n");
1221 return 0;
1222#else
1223 printf(", expected version 0.9.0 (API version 9) or higher\n");
1224 return 1;
1225#endif
1226}
1227EOF
1228 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1229 test_execute
1230 fi
1231}
1232
1233
1234#
1235# Check for the X libraries (Xext, X11)
1236#
1237check_x()
1238{
1239 test_header "X libraries"
1240 cat > $ODIR.tmp_src.cc << EOF
1241#include <cstdio>
1242#include <X11/Xlib.h>
1243extern "C" int main(void)
1244{
1245 Display *dpy;
1246 int scrn_num;
1247 Screen *scrn;
1248 Window win;
1249
1250 dpy = XOpenDisplay(NULL);
1251 scrn_num = DefaultScreen(dpy);
1252 scrn = ScreenOfDisplay(dpy, scrn_num);
1253 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1254 0, 16, InputOutput, CopyFromParent, 0, NULL);
1255 XDestroyWindow(dpy, win);
1256 XCloseDisplay(dpy);
1257}
1258EOF
1259 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1260 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1261 log_success "found"
1262 fi
1263}
1264
1265
1266#
1267# Check for the Xcursor library, needed by VBoxSDL.
1268#
1269check_xcursor()
1270{
1271 test_header Xcursor
1272 cat > $ODIR.tmp_src.cc << EOF
1273#include <cstdio>
1274#include <X11/Xlib.h>
1275#include <X11/Xcursor/Xcursor.h>
1276extern "C" int main(void)
1277{
1278 XcursorImage *cursor = XcursorImageCreate (10, 10);
1279 XcursorImageDestroy(cursor);
1280 return 0;
1281}
1282EOF
1283 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1284 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1285 log_success "found"
1286 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1287 fi
1288}
1289
1290
1291#
1292# Check for the Xinerama library, needed by the Qt GUI
1293#
1294check_xinerama()
1295{
1296 test_header Xinerama
1297 cat > $ODIR.tmp_src.cc << EOF
1298#include <X11/Xlib.h>
1299#include <X11/extensions/Xinerama.h>
1300extern "C" int main(void)
1301{
1302 Display *dpy;
1303 Bool flag;
1304 dpy = XOpenDisplay(NULL);
1305 if (dpy)
1306 {
1307 flag = XineramaIsActive(dpy);
1308 XCloseDisplay(dpy);
1309 }
1310}
1311EOF
1312 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1313 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1314 log_success "found"
1315 fi
1316}
1317
1318
1319#
1320# Check for the Xinerama library, needed by the Qt GUI
1321#
1322check_xrandr()
1323{
1324 test_header Xrandr
1325 cat > $ODIR.tmp_src.cc << EOF
1326#include <X11/Xlib.h>
1327#include <X11/extensions/Xrandr.h>
1328extern "C" int main(void)
1329{
1330 Display *dpy;
1331 Bool flag;
1332 int major, minor;
1333 dpy = XOpenDisplay(NULL);
1334 if (dpy)
1335 {
1336 flag = XRRQueryVersion(dpy, &major, &minor);
1337 XCloseDisplay(dpy);
1338 }
1339}
1340EOF
1341 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1342 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1343 log_success "found"
1344 fi
1345}
1346
1347
1348#
1349# Check for OpenGL
1350#
1351check_opengl()
1352{
1353 # On darwin this is a on/off decision only
1354 if [ "$OS" = "darwin" ]; then
1355 test_header "OpenGL support"
1356 echo "enabled"
1357 cnf_append "VBOX_WITH_CROGL" "1"
1358 else
1359 check_xmu
1360 check_mesa
1361 fi
1362}
1363
1364
1365#
1366# Check for the Xmu library, needed by OpenGL
1367#
1368check_xmu()
1369{
1370 test_header Xmu
1371 cat > $ODIR.tmp_src.cc << EOF
1372#include <cstdio>
1373#include <X11/Xatom.h>
1374#include <X11/Xlib.h>
1375#include <X11/Xutil.h>
1376#include <X11/Xmu/StdCmap.h>
1377extern "C" int main(void)
1378{
1379 Display *dpy;
1380 int scrn_num;
1381 Screen *scrn;
1382
1383 dpy = XOpenDisplay(NULL);
1384 if (dpy)
1385 {
1386 scrn_num = DefaultScreen(dpy);
1387 scrn = ScreenOfDisplay(dpy, scrn_num);
1388 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1389 24, XA_RGB_DEFAULT_MAP, False, True);
1390 printf("Status = %x\n", status);
1391 XCloseDisplay(dpy);
1392 }
1393 return 0;
1394}
1395EOF
1396 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1397 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1398 log_success "found"
1399 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1400 fi
1401}
1402
1403#
1404# Check for Mesa, needed by OpenGL
1405#
1406check_mesa()
1407{
1408 test_header "Mesa / GLU"
1409 cat > $ODIR.tmp_src.cc << EOF
1410#include <cstdio>
1411#include <X11/Xlib.h>
1412#include <GL/glx.h>
1413#include <GL/glu.h>
1414extern "C" int main(void)
1415{
1416 Display *dpy;
1417 int major, minor;
1418
1419 dpy = XOpenDisplay(NULL);
1420 if (dpy)
1421 {
1422 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1423 XCloseDisplay(dpy);
1424 if (glx_version)
1425 {
1426 printf("found version %u.%u, OK.\n", major, minor);
1427 return 0;
1428 }
1429 }
1430 printf("found (inactive), OK.\n");
1431 return 0;
1432}
1433EOF
1434 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1435 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1436 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1437 test_execute
1438 fi
1439}
1440
1441
1442#
1443# Check for the Qt4 library, needed by the VirtualBox frontend
1444#
1445# Currently not fatal.
1446#
1447check_qt4()
1448{
1449 foundqt4=
1450 test_header Qt4
1451 if [ "$OS" = "darwin" ]; then
1452 # First check if there is the internal version of Qt. If yes nothing else
1453 # has to be done.
1454 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1455 for t in $QT_INTERNAL; do
1456 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1457 cnf_append "VBOX_WITH_QT4_SUN" "1"
1458 log_success "use internal version"
1459 return
1460 fi
1461 done
1462 # Now try the user provided directory and some of the standard directories.
1463 QT_TRIES="$QT4DIR /System/Library /Library"
1464 for t in $QT_TRIES; do
1465 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1466 PATH_SDK_QT4="$t"
1467 break
1468 fi
1469 done
1470 # Add the necessary params for building the test application
1471 if [ -n "$PATH_SDK_QT4" ]; then
1472 foundqt4=1
1473 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1474 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1475 FLGQT4="-framework QtCore"
1476 else
1477 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1478 fail
1479 fi
1480 else
1481 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1482 # default is to use pkg-config
1483 if which_wrapper pkg-config > /dev/null; then
1484 # this braindead path is necessary for mdv2008.1
1485 qt4_ver=`\
1486 PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib/qt4/lib/pkgconfig \
1487 pkg-config QtCore --modversion 2>> $LOG`
1488 if [ $? -ne 0 ]; then
1489 log_failure "QtCore not found"
1490 fail
1491 else
1492 FLGQT4=`\
1493 PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib/qt4/lib/pkgconfig \
1494 pkg-config QtCore --cflags`
1495 INCQT4=`strip_I "$FLGQT4"`
1496 LIBQT4=`\
1497 PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib/qt4/lib/pkgconfig \
1498 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1499 pkg-config QtCore --libs`
1500 foundqt4=1
1501 fi
1502 else
1503 log_failure "pkg-config not found"
1504 fail
1505 fi
1506 else
1507 # do it the old way (e.g. user has specified QT4DIR)
1508 cat > $ODIR.tmp_src.cc << EOF
1509#include <cstdio>
1510#include <QtGlobal>
1511extern "C" int main(void)
1512{
1513 printf("found version %s", QT_VERSION_STR);
1514#if QT_VERSION >= 0x040602
1515 printf(", OK.\n");
1516 return 0;
1517#else
1518 printf(", expected version 4.6.2 or higher\n");
1519 return 1;
1520#endif
1521}
1522EOF
1523 for q in $QT4DIR; do
1524 INCQT4="$q/include $q/include/QtCore"
1525 FLGQT4="-DQT_SHARED"
1526 I_INCQT4=`prefix_I "$INCQT4"`
1527 LIBQT4="-L$q/lib -lQtCoreVBox"
1528 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1529 foundqt4=2
1530 break;
1531 fi
1532 LIBQT4="-L$q/lib -lQtCore"
1533 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1534 foundqt4=1
1535 break;
1536 fi
1537 done
1538 fi
1539 fi
1540 if [ -n "$foundqt4" ]; then
1541 cat > $ODIR.tmp_src.cc << EOF
1542#include <cstdio>
1543#include <QtGlobal>
1544extern "C" int main(void)
1545{
1546 printf("found version %s", QT_VERSION_STR);
1547#if QT_VERSION >= 0x040602
1548 printf(", OK.\n");
1549 return 0;
1550#else
1551 printf(", expected version 4.6.2 or higher\n");
1552 return 1;
1553#endif
1554}
1555EOF
1556 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1557 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1558 if test_execute_path "`strip_L "$LIBQT4"`"; then
1559 if [ "$OS" = "darwin" ]; then
1560 # Successful build & run the test application so add the necessary
1561 # params to AutoConfig.kmk
1562 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1563 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1564 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1565 # Check for the moc tool in the Qt directory found & some standard
1566 # directories.
1567 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1568 if which_wrapper "$q/bin/moc" > /dev/null; then
1569 cnf_append "PATH_TOOL_QT4" "$q"
1570 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1571 fi
1572 done
1573 else
1574 # strip .../QtCore as we add components ourself
1575 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1576 # store only the first path, remove all other pathes
1577 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1578 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1579 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1580 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1581 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1582 # this is not quite right since the qt libpath does not have to be first...
1583 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1584 if [ "$foundqt4" = "2" ]; then
1585 cnf_append "VBOX_WITH_QT4_SUN" "1"
1586 fi
1587 test_header "Qt4 devtools"
1588 for q in $QT4DIR; do
1589 # first try it with a suffix, some platforms use that
1590 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1591 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1592 if [ $? -ne 0 ]; then
1593 log_failure "moc-qt4 not working"
1594 fail
1595 else
1596 log_success "found version $moc_ver"
1597 cnf_append "VBOX_PATH_QT4" "$q"
1598 cnf_append "PATH_SDK_QT4" "$q"
1599 cnf_append "PATH_TOOL_QT4" "$q"
1600 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1601 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1602 return
1603 fi
1604 elif which_wrapper "$q/bin/moc" > /dev/null; then
1605 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1606 if [ $? -ne 0 ]; then
1607 log_failure "moc not working"
1608 fail
1609 else
1610 log_success "found version $moc_ver"
1611 cnf_append "VBOX_PATH_QT4" "$q"
1612 cnf_append "PATH_SDK_QT4" "$q"
1613 cnf_append "PATH_TOOL_QT4" "$q"
1614 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1615 return
1616 fi
1617 fi
1618 done
1619 fi
1620 fi
1621 else
1622 log_failure "qt4 not working"
1623 fail
1624 fi
1625 else
1626 log_failure "qt4 not found"
1627 fail
1628 fi
1629}
1630
1631#
1632# Check for libvpx
1633#
1634check_vpx()
1635{
1636 if [ -z "$BUILD_LIBVPX" ]; then
1637 test_header libvpx
1638 if which_wrapper pkg-config > /dev/null; then
1639 libvpx_ver=`pkg-config vpx --modversion 2>> $LOG`
1640 if [ $? -eq 0 ]; then
1641 FLGVPX=`pkg-config vpx --cflags`
1642 INCVPX=`strip_I "$FLGVPX"`
1643 LIBVPX=`pkg-config vpx --libs`
1644 fi
1645 cat > $ODIR.tmp_src.cc << EOF
1646#include <cstdio>
1647#include <vpx/vpx_codec.h>
1648extern "C" int main(void)
1649{
1650 int version = vpx_codec_version();
1651 int verMajor = VPX_VERSION_MAJOR(version);
1652 int verMinor = VPX_VERSION_MINOR(version);
1653 int verPatch = VPX_VERSION_PATCH(version);
1654 printf("found version %d.%d.%d", verMajor, verMinor, verPatch);
1655 if ( verMajor == 1 && verMinor >= 0
1656 || verMajor == 0 && verMinor == 9 && verPatch >= 5)
1657 {
1658 printf(", OK.\n");
1659 return 0;
1660 }
1661 else
1662 {
1663 printf(", expected version 0.9.5 or higher\n");
1664 return 1;
1665 }
1666}
1667EOF
1668 [ -n "$INCVPX" ] && I_INCVPX=`prefix_I "$INCVPX"`
1669 if test_compile "$LIBVPX $I_INCVPX" vpx vpx; then
1670 if test_execute; then
1671 cnf_append "SDK_VBOX_VPX_INCS" "$INCVPX"
1672 cnf_append "SDK_VBOX_VPX_LIBS" "`strip_l "$LIBVPX"`"
1673 fi
1674 fi
1675 fi
1676 fi
1677}
1678
1679
1680#
1681# Check whether static libstdc++ is installed. This library is required
1682# for the Linux guest additions.
1683#
1684check_staticlibstdcxx()
1685{
1686 test_header "static stc++ library"
1687 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1688 cat > $ODIR.tmp_src.cc << EOF
1689#include <string>
1690
1691extern "C" int main(void)
1692{
1693 std::string s = "test";
1694 return 0;
1695}
1696EOF
1697 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1698 log_success "found"
1699 fi
1700}
1701
1702
1703#
1704# Check for Linux sources
1705#
1706check_linux()
1707{
1708 test_header "Linux kernel sources"
1709 cat > $ODIR.tmp_src.c << EOF
1710#include <linux/version.h>
1711int printf(const char *format, ...);
1712int main(void)
1713{
1714 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1715 (LINUX_VERSION_CODE % 65536) / 256,
1716 LINUX_VERSION_CODE % 256);
1717#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1718 printf(", OK.\n");
1719 return 0;
1720#else
1721 printf(", expected version 2.4.0 or higher\n");
1722 return 1;
1723#endif
1724}
1725EOF
1726 echo "compiling the following source file:" >> $LOG
1727 cat $ODIR.tmp_src.c >> $LOG
1728 echo "using the following command line:" >> $LOG
1729 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1730 "-I$LINUX/include/generated/uapi" >> $LOG
1731 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1732 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1733 if [ $? -ne 0 ]; then
1734 echo
1735 echo " Linux kernel headers not found at $LINUX"
1736 echo " Check the file $LOG for detailed error information."
1737 fail
1738 else
1739 if test_execute; then
1740 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1741 fi
1742 fi
1743}
1744
1745
1746#
1747# Check for kchmviewer, needed to display the online help
1748# (unused as we ship kchmviewer)
1749#
1750check_kchmviewer()
1751{
1752 test_header kchmviewer
1753 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1754 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1755 if [ $? -ne 0 ]; then
1756 log_failure "kchmviewer not working"
1757 fail
1758 else
1759 log_success "found version $kchmviewer_ver"
1760 fi
1761 fi
1762}
1763
1764
1765#
1766# Check for the kBuild tools, we don't support GNU make
1767#
1768check_kbuild()
1769{
1770 test_header kBuild
1771 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1772 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1773 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1774 echo "export PATH_KBUILD" >> $ENV
1775 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1776 echo "export PATH_DEVTOOLS" >> $ENV
1777 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1778 echo "export PATH_KBUILD_BIN" >> $ENV
1779 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1780 if [ "$OS" = "solaris" ]; then
1781 # Because of sh being non-default shell in Solaris we need to export PATH again when
1782 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1783 echo "PATH=\"$ORGPATH\"" >> $ENV
1784 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1785 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1786 else
1787 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1788 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1789 fi
1790 echo "export PATH" >> $ENV
1791 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1792 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1793 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1794 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1795 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1796 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1797 echo "export PATH_KBUILD" >> $ENV
1798 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1799 echo "export PATH_DEVTOOLS" >> $ENV
1800 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1801 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1802 echo "export PATH_KBUILD_BIN" >> $ENV
1803 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1804 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1805 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1806 echo "export PATH" >> $ENV
1807 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1808 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1809 elif check_avail "kmk" KBUILDDIR really; then
1810 # check for installed kBuild
1811 KBUILD_SED="`which_wrapper kmk_sed`"
1812 else
1813 fail
1814 fi
1815 log_success "found"
1816}
1817
1818
1819#
1820# Check for compiler.h
1821# Some Linux distributions include "compiler.h" in their libc linux
1822# headers package, some don't. Most don't need it, building might (!)
1823# not succeed on openSUSE without it.
1824#
1825# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1826#
1827check_compiler_h()
1828{
1829 test_header compiler.h
1830 if ! test -f "/usr/include/linux/compiler.h"; then
1831 log_success "compiler.h not found"
1832 else
1833 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1834 log_success "compiler.h found"
1835 fi
1836}
1837
1838#
1839# Check for libcap.
1840# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1841# sockets for doing ICMP requests.
1842#
1843check_libcap()
1844{
1845 test_header "libcap library"
1846 cat > $ODIR.tmp_src.cc << EOF
1847#include <cstdio>
1848#include <sys/types.h>
1849#include <linux/types.h>
1850#include <sys/capability.h>
1851
1852extern "C" int main(void)
1853{
1854 char buf[1024];
1855 cap_t caps = cap_get_proc();
1856 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1857 return 0;
1858}
1859EOF
1860 if test_compile $LIBCAP libcap libcap; then
1861 if test_execute; then
1862 log_success "found"
1863 fi
1864 fi
1865}
1866
1867#
1868# Check if we are able to build 32-bit applications (needed for the guest additions)
1869#
1870check_32bit()
1871{
1872 test_header "32-bit support"
1873 cat > $ODIR.tmp_src.c << EOF
1874#include <stdint.h>
1875int main(void)
1876{
1877 return 0;
1878}
1879EOF
1880 echo "compiling the following source file:" >> $LOG
1881 cat $ODIR.tmp_src.c >> $LOG
1882 echo "using the following command line:" >> $LOG
1883 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1884 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1885 if [ $? -ne 0 ]; then
1886 echo
1887 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1888 echo " Check the file $LOG for detailed error information."
1889 fail
1890 else
1891 echo "executing the binary" >> $LOG
1892 $ODIR.tmp_out 2> $ODIR.test_execute.log
1893 rc=$?
1894 cat $ODIR.test_execute.log >> $LOG
1895 if [ $rc -ne 0 ]; then
1896 echo
1897 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1898 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1899 fail
1900 return 1
1901 fi
1902 fi
1903 log_success ""
1904}
1905
1906
1907#
1908# Check for Python
1909#
1910check_python()
1911{
1912 test_header "Python support"
1913
1914 # On darwin this is a on/off decision only
1915 if [ "$OS" = "darwin" ]; then
1916 echo "enabled"
1917 cnf_append "VBOX_WITH_PYTHON" "1"
1918 return
1919 fi
1920
1921 cat > $ODIR.tmp_src.cc << EOF
1922#include <cstdio>
1923#include <Python.h>
1924extern "C" int main(void)
1925{
1926 Py_Initialize();
1927 printf("found version %s", PY_VERSION);
1928#if PY_VERSION_HEX >= 0x02030000
1929 printf(", OK.\n");
1930 return 0;
1931#else
1932 printf(", expected version 2.3 or higher\n");
1933 return 1;
1934#endif
1935}
1936EOF
1937 found=
1938# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1939 if [ "$OS" != "solaris" ]; then
1940 SUPPYTHONLIBS="python2.7 python2.6 python2.5 python2.4 python2.3"
1941 else
1942 SUPPYTHONLIBS="python2.4"
1943 fi
1944 for p in $PYTHONDIR; do
1945 for d in $SUPPYTHONLIBS; do
1946 for b in lib/x86_64-linux-gnu lib/i386-linux-gnu lib64 lib/64 lib; do
1947 echo "compiling the following source file:" >> $LOG
1948 cat $ODIR.tmp_src.cc >> $LOG
1949 echo "using the following command line:" >> $LOG
1950 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1951 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1952 if [ $? -eq 0 ]; then
1953 found=1
1954 break
1955 fi
1956 done
1957 if [ -n "$found" ]; then break; fi
1958 done
1959 if [ -n "$found" ]; then break; fi
1960 done
1961 if [ -n "$found" ]; then
1962 if test_execute; then
1963 cnf_append "VBOX_WITH_PYTHON" "1"
1964 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1965 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1966 else
1967 log_failure "Python not working"
1968 fail
1969 fi
1970 else
1971 log_failure "Python not found"
1972 fail
1973 fi
1974}
1975
1976
1977#
1978# Check for Java
1979#
1980check_java()
1981{
1982 test_header "Java support"
1983 log_success
1984}
1985
1986
1987#
1988# Setup wine
1989#
1990setup_wine()
1991{
1992 test_header "Wine support"
1993 if ! which_wrapper wine > /dev/null; then
1994 echo " wine binary not found"
1995 fail
1996 fi
1997 if ! which_wrapper wine > /dev/null; then
1998 echo " wine not found"
1999 fail
2000 fi
2001 wine_version="`wine --version`"
2002 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
2003 "0")
2004 if ! which_wrapper wineprefixcreate > /dev/null; then
2005 echo " wineprefixcreate not found"
2006 fail
2007 fi
2008 ;;
2009 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
2010 esac
2011 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
2012 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
2013 echo "export WINEPREFIX" >> $ENV
2014 rm -rf $WINEPREFIX
2015 mkdir -p $WINEPREFIX
2016 touch $WINEPREFIX/.no_prelaunch_window_flag
2017 if ! wineprefixcreate -q > /dev/null 2>&1; then
2018 echo " wineprefixcreate failed"
2019 fail
2020 fi
2021 tmp=.tmp.wine.reg
2022 rm -f $tmp
2023 echo 'REGEDIT4' > $tmp
2024 echo '' >> $tmp
2025 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
2026 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
2027 echo '' >> $tmp
2028 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
2029 echo '"itss"="native"' >> $tmp
2030 echo '' >> $tmp
2031 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
2032 echo '"itss"="native"' >> $tmp
2033 echo '' >> $tmp
2034 if ! wine regedit $tmp > /dev/null 2>&1; then
2035 rm -f $tmp
2036 echo " failed to load registry changes (path)."
2037 fail
2038 fi
2039 rm -f $tmp
2040 log_success "found"
2041}
2042
2043
2044#
2045# Check for gSOAP.
2046#
2047check_gsoap()
2048{
2049 test_header "GSOAP compiler"
2050 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
2051 if which_wrapper pkg-config > /dev/null; then
2052 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2053 if [ $? -eq 0 ]; then
2054 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2055 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2056 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2057 GSOAP_IMPORT="$GSOAP/include/gsoap"
2058 fi
2059 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2060 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2061 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2062 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2063 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2064 else
2065 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2066 fi
2067 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2068 gsoap_version=`pkg-config gsoapssl++ --modversion`
2069 log_success "found version $gsoap_version"
2070 return
2071 fi
2072 fi
2073 fi
2074 if [ -z "$GSOAP" ]; then
2075 GSOAP="/usr"
2076 fi
2077 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2078 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2079 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2080 # TODO: Check for libgsoap++.a/so
2081
2082 if [ -z "$GSOAP_IMPORT" ]; then
2083 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2084 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2085 GSOAP_IMPORT="$GSOAP/include/gsoap"
2086 fi
2087 fi
2088 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2089 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2090 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2091 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2092 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2093 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2094 else
2095 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2096 fi
2097 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2098 log_success "found"
2099 else
2100 log_failure "stlvector.h not found -- disabling webservice"
2101 cnf_append "VBOX_WITH_WEBSERVICES" ""
2102 fi
2103 else
2104 log_failure "stdsoap2.h not found -- disabling webservice"
2105 cnf_append "VBOX_WITH_WEBSERVICES" ""
2106 fi
2107 else
2108 log_failure "wsdl2h not found -- disabling webservice"
2109 cnf_append "VBOX_WITH_WEBSERVICES" ""
2110 fi
2111 else
2112 log_failure "soapcpp2 not found -- disabling webservice"
2113 cnf_append "VBOX_WITH_WEBSERVICES" ""
2114 fi
2115}
2116
2117
2118#
2119# Determines the Darwin version.
2120# @todo This should really check the Xcode/SDK version.
2121#
2122check_darwinversion()
2123{
2124 test_header "Darwin version"
2125 darwin_ver=`uname -r`
2126 case "$darwin_ver" in
2127 11\.*)
2128 darwin_ver="10.7" # Lion
2129 sdk=/Developer/SDKs/MacOSX10.6.sdk
2130 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2131 ;;
2132 10\.*)
2133 darwin_ver="10.6" # Snow Leopard
2134 if [ "$BUILD_MACHINE" = "x86" ]; then
2135 sdk=/Developer/SDKs/MacOSX10.5.sdk
2136 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2137 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2138 else
2139 sdk=/Developer/SDKs/MacOSX10.6.sdk
2140 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2141 fi
2142# test "$CC" = "gcc" && CC="gcc-4.0"
2143# test "$CXX" = "g++" && CXX="g++-4.0"
2144 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2145 ;;
2146 9\.*)
2147 darwin_ver="10.5" # Leopard
2148 sdk=/Developer/SDKs/MacOSX10.5.sdk
2149 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2150# test "$CC" = "gcc" && CC="gcc-4.0"
2151# test "$CXX" = "g++" && CXX="g++-4.0"
2152 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2153 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2154 ;;
2155 8\.*)
2156 darwin_ver="10.4" # Tiger
2157 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2158 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2159# test "$CC" = "gcc" && CC="gcc-4.0"
2160# test "$CXX" = "g++" && CXX="g++-4.0"
2161 cnf_append "VBOX_WITH_COCOA_QT" ""
2162 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2163 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2164 ;;
2165 *)
2166 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2167 fail
2168 darwin_ver="unknown"
2169 ;;
2170 esac
2171 log_success "found version $darwin_ver (SDK: $sdk)"
2172}
2173
2174
2175check_makeself()
2176{
2177 test_header "makeself"
2178 if check_avail "$MAKESELF" makeself; then
2179 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2180 if [ $? -ne 0 ]; then
2181 log_failure "makeself not working"
2182 fail
2183 else
2184 log_success "found version $makeself_ver"
2185 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2186 fi
2187 fi
2188}
2189
2190
2191#
2192# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2193# is around to prevent confusion when the build fails in src/recompiler.
2194# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2195#
2196check_i386elfgcc()
2197{
2198 test_header "i386-elf-gcc"
2199 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2200 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2201 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2202 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2203 if test -z "$i386_elf_gcc"; then
2204 echo " failed to find i386-elf-gcc"
2205 fail
2206 fi
2207 log_success "found $i386_elf_gcc"
2208}
2209
2210
2211#
2212# Show help
2213#
2214show_help()
2215{
2216cat << EOF
2217Usage: ./configure [OPTIONS]...
2218
2219Configuration:
2220 -h, --help display this help and exit
2221 --nofatal don't abort on errors
2222EOF
2223[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2224[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2225[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2226[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2227[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2228[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2229[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2230[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2231[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2232[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2233[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2234[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2235[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2236[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2237[ $WITH_LIBVPX -eq 1 ] && echo " --disable-libvpx don't use libvpx for video capturing"
2238[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2239cat << EOF
2240 --disable-udptunnel disable UDP tunnel networking
2241 --disable-devmapper disable device mapper library access
2242 --disable-hardening don't be strict about /dev/vboxdrv access
2243 --build-libxml2 build libxml2 from sources
2244EOF
2245[ $OSE -eq 0 ] && cat << EOF
2246 --build-libssl build openssl from sources
2247 --build-libcurl build libcurl from sources
2248 --build-libvpx build libvpx from sources
2249EOF
2250[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2251cat << EOF
2252
2253Paths:
2254 --with-gcc=PATH location of the gcc compiler [$CC]
2255 --with-g++=PATH location of the g++ compiler [$CXX]
2256 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2257 --with-iasl=PATH location of the iasl compiler [$IASL]
2258 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2259 --with-makeself=PATH location of makeself [$MAKESELF]
2260EOF
2261[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2262[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2263[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2264[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2265[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2266cat << EOF
2267 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2268 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2269 --out-path=PATH the folder to which configuration and build output
2270 should go
2271
2272Build type:
2273 -d, --build-debug build with debugging symbols and assertions
2274 --build-profile build with profiling support
2275 --build-headless build headless (without any GUI frontend)
2276EOF
2277 exit 0
2278}
2279
2280
2281#
2282# The body.
2283#
2284
2285# test if we are OSE
2286if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2287 OSE=0
2288 # Set this as a reminder to print a log message once we know the path of the
2289 # log file
2290 NOT_OSE=1
2291fi
2292
2293# Change OS specific defaults; must be before all other stuff
2294if [ "$OS" = "darwin" ]; then
2295 WITH_SDL=0
2296 WITH_SDL_TTF=0
2297 WITH_X11=0
2298 WITH_ALSA=0
2299 WITH_PULSE=0
2300 WITH_DBUS=0
2301 WITH_KMODS=0
2302 BUILD_LIBXML2=1
2303 BUILD_LIBVPX=1
2304 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2305 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2306elif [ "$OS" = "haiku" ]; then
2307 #WITH_SDL=0
2308 WITH_SDL_TTF=0
2309 WITH_X11=0
2310 WITH_ALSA=0
2311 WITH_PULSE=0
2312 WITH_DBUS=0
2313 WITH_KMODS=0
2314 WITH_LIBIDL=0
2315 WITH_XPCOM=0
2316 BUILD_LIBXSLT=1
2317 BUILD_LIBXML2=1
2318 WITH_LIBVPX=0
2319 # it is part of libroot, which is linked by default,
2320 # but the script wants something
2321 LIBPTHREAD="-lroot"
2322 #[ $OSE -eq 1 ] || BUILD_LIBCURL=1
2323 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2324elif [ "$OS" = "solaris" ]; then
2325 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2326fi
2327
2328# scan command line options
2329for option in $*; do
2330 case "$option" in
2331 --help|-help|-h)
2332 show_help
2333 ;;
2334 --nofatal)
2335 nofatal=1
2336 ;;
2337 --env-only)
2338 ENV_ONLY=1
2339 ;;
2340 --with-gcc=*)
2341 CC=`echo $option | cut -d'=' -f2`
2342 ;;
2343 --with-g++=*)
2344 CXX=`echo $option | cut -d'=' -f2`
2345 ;;
2346 --with-kbuild=*)
2347 KBUILDDIR=`echo $option | cut -d'=' -f2`
2348 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2349 echo "Error: KBUILDDIR contains invalid characters!"
2350 exit 1
2351 fi
2352 ;;
2353 --with-qt-dir=*|--with-qt4-dir=*)
2354 QT4DIR=`echo $option | cut -d'=' -f2`
2355 QT4DIR_PKGCONFIG=0
2356 ;;
2357 --with-openssl-dir=*)
2358 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2359 INCCRYPTO="-I${OPENSSLDIR}/include"
2360 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2361 ;;
2362 --with-ow-dir=*)
2363 WATCOM=`echo $option | cut -d'=' -f2`
2364 ;;
2365 --with-gsoap-dir=*)
2366 GSOAP=`echo $option | cut -d'=' -f2`
2367 ;;
2368 --with-gsoap-import=*)
2369 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2370 ;;
2371 --with-iasl=*)
2372 IASL=`echo $option | cut -d'=' -f2`
2373 ;;
2374 --with-linux=*)
2375 LINUX=`echo $option | cut -d'=' -f2`
2376 ;;
2377 --with-mkisofs=*)
2378 MKISOFS=`echo $option | cut -d'=' -f2`
2379 ;;
2380 --with-makeself=*)
2381 MAKESELF=`echo $option | cut -d'=' -f2`
2382 ;;
2383 --target-arch=*)
2384 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2385 ;;
2386 --disable-xpcom)
2387 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2388 ;;
2389 --disable-python)
2390 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2391 ;;
2392 --disable-java)
2393 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2394 ;;
2395 --disable-vmmraw)
2396 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2397 ;;
2398 --disable-sdl-ttf)
2399 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2400 ;;
2401 --disable-qt)
2402 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2403 ;;
2404 --disable-qt4)
2405 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2406 ;;
2407 --passive-mesa)
2408 PASSIVE_MESA=1
2409 ;;
2410 --disable-alsa)
2411 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2412 ;;
2413 --disable-pulse)
2414 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2415 ;;
2416 --enable-pulse)
2417 WITH_PULSE=2
2418 ;;
2419 --disable-dbus)
2420 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2421 ;;
2422 --disable-kmods)
2423 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2424 ;;
2425 --disable-opengl)
2426 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2427 ;;
2428 --enable-webservice)
2429 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2430 ;;
2431 --enable-vnc)
2432 WITH_VNC=1
2433 ;;
2434 --disable-hardening)
2435 WITH_HARDENING=0
2436 ;;
2437 --disable-extpack)
2438 WITH_EXTPACK=0
2439 ;;
2440 --disable-docs)
2441 WITH_DOCS=0
2442 ;;
2443 --enable-hardening)
2444 WITH_HARDENING=2
2445 ;;
2446 --disable-udptunnel)
2447 WITH_UDPTUNNEL=0
2448 ;;
2449 --enable-vde)
2450 WITH_VDE=1
2451 ;;
2452 --disable-devmapper)
2453 WITH_DEVMAPPER=0
2454 ;;
2455 --disable-libvpx)
2456 WITH_LIBVPX=0
2457 ;;
2458 --build-debug|-d)
2459 BUILD_TYPE=debug
2460 ;;
2461 --build-profile)
2462 BUILD_TYPE=profile
2463 ;;
2464 --build-libxml2)
2465 BUILD_LIBXML2=1
2466 ;;
2467 --build-libssl)
2468 BUILD_LIBSSL=1
2469 ;;
2470 --build-libcurl)
2471 BUILD_LIBCURL=1
2472 ;;
2473 --build-libvpx)
2474 BUILD_LIBVPX=1
2475 ;;
2476 --build-headless)
2477 HEADLESS=1
2478 WITH_SDL=0
2479 WITH_SDL_TTF=0
2480 WITH_X11=0
2481 WITH_OPENGL=0
2482 WITH_QT4=0
2483 ;;
2484 --ose)
2485 OSE=2
2486 ;;
2487 --odir=*)
2488 ODIR="`echo $option | cut -d'=' -f2`/"
2489 ODIR_OVERRIDE=1
2490 ;;
2491 --out-path=*)
2492 out_path="`echo $option | cut -d'=' -f2`/"
2493 if [ -d $out_path ]; then
2494 saved_path="`pwd`"
2495 cd $out_path
2496 OUT_PATH="`pwd`"
2497 cd $saved_path
2498 OUT_PATH_OVERRIDE=1
2499 if [ $ODIR_OVERRIDE -eq 0 ]; then
2500 # This variable has not *yet* been overridden. That can still happen.
2501 ODIR=$OUT_PATH/
2502 fi
2503 else
2504 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2505 exit 1
2506 fi
2507 ;;
2508 --setup-wine)
2509 [ "$OS" != "darwin" ] && SETUP_WINE=1
2510 ;;
2511 *)
2512 echo
2513 echo "Unrecognized option \"$option\""
2514 echo
2515 show_help
2516 ;;
2517 esac
2518done
2519
2520LOG="$ODIR$LOG"
2521ENV="$ODIR$ENV"
2522CNF="$ODIR$CNF"
2523
2524# initialize output files
2525cat > $LOG << EOF
2526# Log file generated by
2527#
2528# '$0 $*'
2529#
2530
2531EOF
2532cat > $CNF << EOF
2533# -*- Makefile -*-
2534#
2535# automatically generated by
2536#
2537# '$0 $*'
2538#
2539# It will be completely overwritten if configure is executed again.
2540#
2541
2542EOF
2543cat > $ENV << EOF
2544#!/bin/bash
2545#
2546# automatically generated by
2547#
2548# '$0 $*'
2549#
2550# It will be completely overwritten if configure is executed again.
2551# Make sure you source this file once before you start to build VBox.
2552#
2553
2554EOF
2555
2556# Print log warning about OSE if necessary
2557if [ -n "$NOT_OSE" ]; then
2558 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2559 echo >> $LOG
2560fi
2561
2562
2563if [ "$BUILD_TYPE" = "debug" ]; then
2564 echo "Creating DEBUG build!" >> $LOG
2565elif [ "$BUILD_TYPE" = "profile" ]; then
2566 echo "Creating PROFILE build!" >> $LOG
2567fi
2568
2569# first determine our environment
2570check_environment
2571check_kbuild
2572
2573[ -n "$ENV_ONLY" ] && exit 0
2574
2575# append the tools directory to the default search path
2576echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2577export PATH
2578
2579# if we will be writing to a different out directory then set this up now
2580if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2581 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2582 echo "export AUTOCFG" >> $ENV
2583 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2584 echo "export LOCALCFG" >> $ENV
2585 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2586 echo "export PATH_OUT_BASE" >> $ENV
2587fi
2588
2589# some things are not available in for OSE
2590if [ $OSE -ge 1 ]; then
2591 cnf_append "VBOX_OSE" "1"
2592 cnf_append "VBOX_WITH_TESTSUITE" ""
2593 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2594
2595 if [ "$OS" = "linux" ]; then
2596 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2597 else
2598 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2599 fi
2600 echo >> $CNF
2601fi
2602
2603# extpack
2604if [ $OSE -eq 0 ]; then
2605 if [ $WITH_EXTPACK -eq 1 ]; then
2606 BUILD_LIBSSL=1
2607 else
2608 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2609 fi
2610fi
2611
2612# headless
2613if [ -n "$HEADLESS" ]; then
2614 cnf_append "VBOX_HEADLESS" "1"
2615fi
2616
2617# emit disable directives corresponding to any --disable-xxx options.
2618if [ $WITH_OPENGL -eq 0 ]; then
2619 cnf_append "VBOX_WITH_CROGL" ""
2620 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2621 cnf_append "VBOX_GUI_USE_QGL" ""
2622fi
2623[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2624[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2625[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2626[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2627[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2628[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2629[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2630[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2631[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2632[ $WITH_LIBVPX -eq 0 ] && cnf_append "VBOX_WITH_VPX" ""
2633
2634# Darwin-specific
2635if [ "$OS" = "darwin" ]; then
2636 check_darwinversion
2637fi
2638# the tools
2639check_gcc
2640check_open_watcom
2641[ "$OS" != "darwin" ] && check_iasl
2642# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2643# [ "$OS" != "darwin" ] && check_yasm
2644[ "$OS" != "darwin" ] && check_xsltproc
2645[ "$OS" != "darwin" ] && check_mkisofs
2646
2647# the libraries
2648[ "$OS" != "darwin" ] && check_pthread
2649check_libxml2
2650[ $WITH_LIBIDL -eq 1 ] && check_libidl
2651check_ssl
2652check_curl
2653[ $WITH_LIBVPX -eq 1 ] && check_vpx
2654[ "$OS" != "darwin" ] && check_z
2655[ "$OS" != "darwin" ] && check_png
2656[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2657[ $WITH_SDL -eq 1 ] && check_sdl
2658[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2659[ $WITH_X11 -eq 1 ] && check_x
2660# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2661# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2662[ $WITH_X11 -eq 1 ] && check_xcursor
2663[ $WITH_X11 -eq 1 ] && check_xinerama
2664[ $WITH_X11 -eq 1 ] && check_xrandr
2665[ $WITH_OPENGL -eq 1 ] && check_opengl
2666[ $WITH_QT4 -eq 1 ] && check_qt4
2667[ $WITH_PYTHON -eq 1 ] && check_python
2668[ $WITH_JAVA -eq 1 ] && check_java
2669
2670# PulseAudio
2671if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2672 if [ $WITH_PULSE -eq 1 ]; then
2673 check_pulse
2674 elif [ $WITH_PULSE -eq 0 ]; then
2675 cnf_append "VBOX_WITH_PULSE" ""
2676 fi
2677fi
2678
2679# Linux-specific
2680if [ "$OS" = "linux" ]; then
2681 # don't check for the static libstdc++ in the PUEL version as we build the
2682 # additions at a dedicated box
2683 [ $OSE -ge 1 ] && check_staticlibstdcxx
2684 if [ $WITH_KMODS -eq 1 ]; then
2685 check_linux
2686 else
2687 cnf_append "VBOX_LINUX_SRC" ""
2688 cnf_append "VBOX_WITH_VBOXDRV" ""
2689 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2690 fi
2691 if [ $WITH_ALSA -eq 1 ]; then
2692 check_alsa
2693 else
2694 cnf_append "VBOX_WITH_ALSA" ""
2695 fi
2696 if [ $WITH_DBUS -eq 0 ]; then
2697 cnf_append "VBOX_WITH_DBUS" ""
2698 fi
2699 if [ $WITH_DEVMAPPER -eq 1 ]; then
2700 check_libdevmapper
2701 else
2702 cnf_append "VBOX_WITH_DEVMAPPER" ""
2703 fi
2704 check_libcap
2705 check_compiler_h
2706 [ "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2707 # tools/common/makeself*
2708 [ $OSE -ge 1 ] && check_makeself
2709fi
2710
2711[ -n "$SETUP_WINE" ] && setup_wine
2712
2713if [ $WITH_GSOAP -eq 1 ]; then
2714 check_gsoap
2715else
2716 if [ $OSE -ge 1 ]; then
2717 cnf_append "VBOX_WITH_WEBSERVICES" ""
2718 fi
2719fi
2720
2721# UDPTUNNEL
2722if [ $WITH_UDPTUNNEL -eq 0 ]; then
2723 cnf_append "VBOX_WITH_UDPTUNNEL" ""
2724fi
2725
2726# VDE
2727if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2728 if [ $WITH_VDE -eq 1 ]; then
2729 cnf_append "VBOX_WITH_VDE" "1"
2730 fi
2731fi
2732
2733# DOCS
2734if [ $WITH_DOCS -eq 0 ]; then
2735 cnf_append "VBOX_WITH_DOCS" ""
2736 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2737fi
2738
2739# VNC server support
2740if [ $OSE -ge 1 ]; then
2741 if [ $WITH_VNC = 1 ]; then
2742 check_vncserver
2743 else
2744 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
2745 fi
2746fi
2747
2748# success!
2749echo
2750echo "Successfully generated '$CNF' and '$ENV'."
2751echo "Source '$ENV' once before you start to build VBox:"
2752echo ""
2753echo " source $ENV"
2754echo " kmk"
2755echo ""
2756if [ "$OS" = "linux" ]; then
2757 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2758 vbox_out_path=$OUT_PATH
2759 else
2760 vbox_out_path=./out
2761 fi
2762 echo "To compile the kernel modules, do:"
2763 echo ""
2764 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2765 echo " make"
2766 echo ""
2767fi
2768if [ $WITH_HARDENING -gt 0 ]; then
2769 echo ""
2770 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2771 echo " Hardening is enabled which means that the VBox binaries will not run from"
2772 echo " the binary directory. The binaries have to be installed suid root and some"
2773 echo " more prerequisites have to be fulfilled which is normally done by installing"
2774 echo " the final package. For development, the hardening feature can be disabled"
2775 echo " by specifying the --disable-hardening parameter. Please never disable that"
2776 echo " feature for the final distribution!"
2777 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2778 echo ""
2779else
2780 echo ""
2781 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2782 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2783 echo " disabled hardening!"
2784 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2785 echo ""
2786fi
2787echo "Enjoy!"
2788cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use